/******************************************
	PURPOSE:	    Cuckoo Clock Project 
	Created by:   Timm Bischoff
	DATE:		      4/05/2016
*******************************************/

#include <Servo.h>  //includes the servo library

Servo millServo;   // create servo object to control a servo
Servo birdservo;       

#define pin1  8     //these are the Arduino pins that we use to activate coils 1-4 of the stepper motor
#define pin2  9
#define pin3  10
#define pin4  11

#define delaytime 80   //delay time in ms to control the stepper motor delaytime.
                       //Tests showed that 8 is about the fastest that can yield reliable operation w/o missing steps

int Button=2;        //connect button to Pin 2
int LED=13;          //connect LED to Pin 13
int LED2 = 12;       //connect more Led to pin 12 if needed
int SPEAKER = 7;    //connect buzzer to Pin 7
int servoPin1 = 4;   // connect the servo that controls the bird
int servoPin2 = 6;   //connect the servo that controls the watermill 

int counter = 0;    //counters that are used throughout the loop
int revolution = 0;

int i = 180;        // statring point for servo
int lastButtonState = LOW;   //toggle state
int hourTime = 2;           // controls number of chirps

void setup() 
{
  // initialize the pins as outputs:
  
  pinMode(pin1, OUTPUT);
  pinMode(pin2, OUTPUT); 
  pinMode(pin3, OUTPUT); 
  pinMode(pin4, OUTPUT);
  pinMode(SPEAKER,OUTPUT);
  pinMode(LED, OUTPUT);
  pinMode(LED2, OUTPUT);

  // initialize the pins as inputs:
  pinMode(Button, INPUT);

  //attaches the servo on pin 4 to the servo object
  birdservo.attach(servoPin1);  
  millServo.attach(servoPin2);


}

void loop(){

  if(counter == 55)   //uses a conditional to make the stepper motor move
  {
   forward();       //jumps to the function forward
    counter = 0;    // resets counter to 0
  millServo.write(i); //watermill moves to that degree
  i=i-2;
  if (i == 0)       // resets watermill back to 180 so it can continue rotating
  {
    i = 180;
  }
  }
  
  delay(10); // controls the speed at which the stepper motor will move: 10= good demo mode. 100=approximately real time.

  // Get the current state of the button
  int currentButtonState = digitalRead(Button);

  // Has the button gone high since we last read it?
  if (currentButtonState == HIGH && lastButtonState == LOW) {
     // Switch the state of the output
     digitalWrite(LED, !digitalRead(LED));
     digitalWrite(LED2, !digitalRead(LED2));
  }

  // Store the button's state so we can tell if it's changed next time round
  lastButtonState = currentButtonState;
  

  if(revolution == 7025)         //one revolution of the minute hand
  { 
    for (int i = 1; i < hourTime; i++)    //as the houtime increses, the number of chirps increase; so that the number of chirps equal the time of hour.
    {
    birdservo.write(45);
    delay(300);
    chirp();          //Jumps to chirp function under functions tab
    delay(200);
    birdservo.write(100); 
    delay(300);
    revolution = 0;
    }
    hourTime++;
    if (hourTime == 14)  // resets hourtime back to 2
    {
      hourTime = 2;    
    }
  }
  
  counter++;
  revolution++;
}







